program Functii;
const NMax=1000;
type PointType=record
                 X,Y:Real;
               end;
     PointVector=array[0..NMax] of PointType;
var N,M:Integer;
    P:PointVector;
    Min:PointType;

procedure ReadData;
{ 1. Citeste datele (A si B).
  2. Calculeaza X si Y de intersectie.
  3. Roteste sistemul cu -45 grade }
var NewN, i:Integer;
begin
  Assign(Input, 'functii.in'); Reset(Input);
  ReadLn(N, M);
  for i:=1 to N do
    ReadLn(P[i].Y, P[i].X);
  Close(Input);
  NewN:=0;
  for i:=1 to N do      { Eliminam punctele care nu au X-ul intre 0 si M }
    if ((P[i].X-P[i].Y)/2<=M) and ((P[i].X-P[i].Y)/2>=0)
      then begin
             Inc(NewN);
             P[NewN]:=P[i];
           end;
  N:=NewN;
end;

procedure Fall(K, N:Integer);
var PAux:PointType;
    Found:Boolean;
    KSon:Integer;
begin
  repeat
    Found:=False;
    if (2*K<=N) and
       ( (P[2*K].X>P[K].X) or
         ((P[2*K].X=P[K].X) and (P[2*K].Y>P[K].Y)))
      then KSon:=2*K
      else KSon:=K;
    if (2*K+1<=N) and
       ( (P[2*K+1].X>P[KSon].X) or
         ((P[2*K+1].X=P[KSon].X) and (P[2*K+1].Y>P[KSon].Y)))
      then KSon:=2*K+1;
    if KSon<>K then begin
                      PAux:=P[K];
                      P[K]:=P[KSon];
                      P[KSon]:=PAux;
                      Found:=True;
                      K:=KSon;
                    end;
  until not Found;
end;

procedure SortPoints;
{ Sorteaza punctele dupa X (pentru X-uri egale, dupa Y). HeapSort }
var PAux:PointType;
    i:Integer;
begin
  for i:=N div 2 downto 1 do Fall(i, N);
  for i:=N downto 2 do
    begin
      PAux:=P[1];
      P[1]:=P[i];
      P[i]:=PAux;
      Fall(1, i-1);
    end;
end;

procedure Sweepy;
{ Matura punctele si le alege pe cele nedominate in O(N) }
var Q:PointVector;     { Stiva de puncte nedominate }
    NewN, i:Integer;   { Nu, marul de puncte nedominate }
begin
  NewN:=0;
  for i:=1 to N do     { Punctul i va domina niste puncte din Q }
    begin
      while (NewN>0) and (P[i].X>=Q[NewN].X) and (P[i].Y>=Q[NewN].Y) do
        Dec(NewN);       { P[i] il domina pe Q[NewN] ==> il zburam din stiva }
      Inc(NewN);
      Q[NewN]:=P[i];
    end;
  P:=Q;
  N:=NewN;
end;

procedure Restore;
{ Roteste inapoi sistemul cu 45 grade }
var i:Integer;
    XP, YP:Real;
begin
  for i:=1 to N do
    with P[i] do
      begin
        XP:=(X-Y)/2;
        YP:=(X+Y)/2;
        X:=XP; Y:=YP;
      end;
end;

procedure FindMin;
var i:Integer;
begin
  Min.Y:=P[1].Y-P[1].X; Min.X:=0;
  if P[N].X+P[N].Y-M<Min.Y
    then begin
           Min.Y:=P[N].X+P[N].Y-M;
           Min.X:=M;
         end;
  for i:=1 to N-1 do
    begin
    if (P[i].X+P[i].Y-P[i+1].X+P[i+1].Y)/2 < Min.Y
      then begin
             Min.X:=(P[i].X+P[i].Y+P[i+1].X-P[i+1].Y)/2;
             Min.Y:=(P[i].X+P[i].Y-P[i+1].X+P[i+1].Y)/2;
           end;
    end;
end;

procedure WriteSolution;
begin
  Assign(Output, 'functii.out'); Rewrite(Output);
  WriteLn(Min.X:0:4, ' ', Min.Y:0:4);
  Close(Output);
end;

begin
  ReadData;
  SortPoints;
  Sweepy;
  Restore;
  FindMin;
  WriteSolution;
end.
