//Directives
#pragma option -mc

//Includes
#include	<stdio.h>
#include        <alloc.h>
#include        <mem.h>
#include        <stdlib.h>
#include        <dos.h>

//Type Definitions
#define         Byte            unsigned char
#define         Word            unsigned short int
#define         DWord           unsigned long int

//Macros
#define         TimeOK          (*CrtTime<TimeOut)
#define         tm(y,x)         ( mmp[(y<<5)+(x>>3)]?( mmp[(y<<5)+(x>>3)] & msk[x&7] ):0)
#define         sm(y,x)         mmp[(y<<5)+(x>>3)]|=msk[x&7];
//Constants
#define		Fin_Name	"input.txt"
#define		Fout_Name	"output.txt"
#define         MaxSeconds      4

#define         MaxP            5000
Byte            msk[8]        = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};
//Global Variables
FILE		*fin, *fout;
long int        *CrtTime;
long int        TimeOut       = 18*MaxSeconds;

int             m, n, p, xmin,xmax,ymin,ymax;
Byte            x[MaxP], y[MaxP];
int             ou, ov, ok;
long            mx, my;
Byte            *mmp;

//Functions Prototypes
void            Init            ();
int             ReadData        ();
void            Compute         ();
void            Done            ();

void    main()
  {
  Init();
  ReadData();
  Compute();
  Done();
  }

void    Init()
  {
  int err;
  CrtTime=(long *)((long)0x046C);
  TimeOut+=*CrtTime;

  if ((mmp=(Byte *)farmalloc(8192))==NULL) {printf("Error!\n");exit(0);}
  memset(mmp,0,8192);

  if (!(fin=fopen(Fin_Name,"rt"))) return;
  remove(Fout_Name);
  if (!(fout=fopen(Fout_Name,"wt"))) return;
  }

void    Done()
  {
  fclose(fin);
  fclose(fout);
  }

int     ReadData()
  {
  int   i;

  fscanf(fin,"%d %d",&m,&n);
  fscanf(fin,"%d",&p);
  for (i=mx=my=0;i<p;i++)
      {
      fscanf(fin,"%d %d",x+i,y+i);
      if (i) {
             if (xmin>x[i]) xmin=x[i];
             if (xmax<x[i]) xmax=x[i];
             if (ymin>y[i]) ymin=y[i];
             if (ymax<y[i]) ymax=y[i];
             }
        else {
             xmin=xmax=x[0];
             ymin=ymax=y[0];
             }
      sm(y[i],x[i]);
      mx+=(long)x[i];
      my+=(long)y[i];
      }
  mx=(mx/p)-(m>>1);
  my=(my/p)-(n>>1);
  if (mx<xmin) mx=xmin;
  if (mx+m>xmax) mx=xmax-m;
  if (my<ymin) my=ymin;
  if (my+n>ymax) my=ymax-n;
  return 1;
  }

int     GetNPts(int yy, int xx)
  {
  int r=0,i,j;

/*  if ((xx>ymax-n)||(yy>xmax-m))
     {
     printf("_ute-l!\n");
     }*/
  for (i=yy;i<=yy+n;i++)
  for (j=xx;j<=xx+m;j++)
      if (tm(i,j)) r+=1;
  return r;
  }

int     GetNPtsRight(int yy, int xx,int vk)
  {
  int   i,j=yy+n,xl=xx-1,xr=xx+m;
  for (i=yy;i<=j;i++)
      {
      if (tm(i,xl)) vk-=1;
      if (tm(i,xr)) vk+=1;
      }
  return vk;
  }

int     GetNPtsDown(int yy, int xx, int vk)
  {
  int   i,j=xx+m,yu=yy-1,yd=yy+n;
  for (i=xx;i<=j;i++)
      {
      if (tm(yu,i)) vk-=1;
      if (tm(yd,i)) vk+=1;
      }
  return vk;
  }

void    Compute()
  {
  int   i,j,r,k,st,en;

  if (p==0)
     {
     fprintf(fout,"0\n1 1\n");
     return;
     }

  ok=GetNPts(ou=my,ov=mx);
  for (r=1;(r<255)&&TimeOK;r++)
      {
      //printf("%c%d",13,r);
      st=mx-r;if (st<xmin) st=xmin;
      en=mx+r;if (en+m>xmax) en=xmax-m;
      if ((i=my-r)>=ymin)
         {
         k=GetNPts(i,st);
         for (j=st+1;j<=en;j++)
             if ((k=GetNPtsRight(i,j,k))>ok) {ok=k;ou=j;ov=i;}
         }
      if ((i=my+r)+n<=ymax)
         {
         k=GetNPts(i,st);
         for (j=st+1;j<=en;j++)
             if ((k=GetNPtsRight(i,j,k))>ok) {ok=k;ou=j;ov=i;}
         }

      st=my-r+1;if (st<ymin) st=ymin;
      en=my+r-1;if (en+n>ymax) en=ymax-n;
      if ((j=mx-r)>=xmin)
         {
         k=GetNPts(st,j);
         for (i=st;i<=en;i++)
             if ((k=GetNPtsDown(i,j,k))>ok) {ok=k;ou=j;ov=i;}
         }
      if ((j=mx+r)+m<=xmax)
         {
         k=GetNPts(st,j);
         for (i=st;i<=en;i++)
             if ((k=GetNPtsDown(i,j,k))>ok) {ok=k;ou=j;ov=i;}
         }
      }
/*
  for (i=1;i<255;i++)
  for (j=1;j<255;j++)
      if (tm(i,j)) printf("%d %d \n",j,i);
  */

  fprintf(fout,"%d\n%d %d\n",ok,ou,ov);
  for (i=ov;i<=ov+n;i++)
  for (j=ou;j<=ou+m;j++)
      {
      if (tm(i,j))
         {
         fprintf(fout,"%d %d\n",j,i);
         }
      }
//  if (TimeOK) printf("OK\n");
  }
